/*jslint node:true,nomen:false */
var matchObj, matchArray;

matchArray = function(ary,search) {
	var matched = false, i, ret = [];
	if (ary && ary.length > 0) {
		for (i=0;i<ary.length;i++) {
			matched = matchObj(ary[i],search);
			if (matched) {
				ret.push(ary[i]);
			}
		}
	}
	return(ret);
};
matchObj = function(obj,search) {
	var i, j, matched, oneMatch, t, re, reMatch, negator, joinAnd;
	search = search || {};
	
	// did we have a negator?
	negator = search._not ? true : false;
	// do we join via AND or OR
	joinAnd = search._join && search._join === "OR" ? false : true;
	// if joinAnd, then matched=true until we have a single non-match; if !joinAnd, then matched=false until we have a single match
	matched = joinAnd ? true : false;
	
	// are we a primitive or a composite?
	if (search.terms) {
		for (j=0; j<search.terms.length; j++) {
			oneMatch = matchObj(obj,search.terms[j]);
			if (negator) {
				oneMatch = !oneMatch;
			}
			// if AND, a single match failure makes all fail, and we break
			// if OR, a single match success makes all succeed, and we break
			if (joinAnd && !oneMatch) {
				matched = false;
				break;
			} else if (!joinAnd && oneMatch) {
				matched = true;
				break;
			}
		}
	} else {
		// match to the search field
		for(i in search) {
			if (search.hasOwnProperty(i) && i.indexOf("_") !== 0) {
				// this one has not yet matched
				oneMatch = false;
				// for numbers, exact match; for strings, ignore-case match; for anything else, no match
				t = typeof(obj[i]);
				if (t === "number") {
					oneMatch = obj[i] === search[i];
				} else if (t === "string") {
					re = new RegExp(search[i],"i");
					oneMatch = obj[i] && obj[i].match(re) !== null;
				}
				// negator
				if (negator) {
					oneMatch = !oneMatch;
				}
				
				// if AND, a single match failure makes all fail, and we break
				// if OR, a single match success makes all succeed, and we break
				if (joinAnd && !oneMatch) {
					matched = false;
					break;
				} else if (!joinAnd && oneMatch) {
					matched = true;
					break;
				}
			}
		}
	}
	
	return(matched);
};

module.exports.matchArray = matchArray;
module.exports.matchObject = matchObj;
